// dcom_channel_info.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f dcom_channel_infops.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "dcom_channel_info.h"

#include "dcom_channel_info_i.c"

#include "channel_hook_impl.h"
#include "tls_manager.h"
#include "ClientInfo.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_ClientInfo, CClientInfo)
END_OBJECT_MAP()

// this is to allow no CRT for tiny dlls
#ifndef _DEBUG
int    __cdecl atexit(void (__cdecl *)(void))
{
    return 0;
}
#endif

void main()
{
}

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    switch (dwReason)
    {
	case DLL_PROCESS_ATTACH:
	{
	    static CChannelHook s_channel_hook;

	    // turn on sockets if not already enabled in this process
	    WSADATA wsad;
	    WSAStartup(MAKEWORD(1,1), &wsad);

	    if (!tls_manager.init())
	    {
		return FALSE;
	    };

	    // register the process-wide channel hook
	    HRESULT hr = CoRegisterChannelHook(CHANNEL_HOOK_ID, &s_channel_hook);
	    if (FAILED(hr))
	    {
		return FALSE;
	    };
	    _Module.Init(ObjectMap, hInstance, &LIBID_DCOM_CHANNEL_INFOLib);
	    DisableThreadLibraryCalls(hInstance);
	}; break;
	case DLL_PROCESS_DETACH:
	{
	    _Module.Term();
	    tls_manager.done();
	}; break;
	case DLL_THREAD_DETACH:
	{
	    tls_manager.release_tls();
	}; break;
	default:
	{
	}; break;
    };
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}
