#include "stdafx.h"
#include "tls_manager.h"

CTLSManager tls_manager;

CTLSManager::CTLSManager()
{
    tls_index = 0xFFFFFFFF;
}

CTLSManager::~CTLSManager()
{
    done();
}

bool CTLSManager::init()
{
    bool b_result = true;
    //allocate new tls slot
    tls_index = TlsAlloc();
    if (tls_index == 0xFFFFFFFF)
    {
        b_result = false;
    };
    return b_result;
}

void CTLSManager::done()
{
    if (tls_index != 0xFFFFFFFF)
    {
	TlsFree(tls_index);
    };
}

CThreadContext* CTLSManager::get_current_thread_context()
{
    CThreadContext* res_value = NULL;
    void* tls_value = TlsGetValue(tls_index);
    if (tls_value == NULL)
    {
	res_value = new CThreadContext();
	TlsSetValue(tls_index, res_value);
    } else
    {
	res_value = reinterpret_cast<CThreadContext*>(tls_value);
    };
    return res_value;
}

void CTLSManager::release_tls()
{
    CThreadContext* tls_value = reinterpret_cast<CThreadContext*>(TlsGetValue(tls_index));
    delete tls_value;
}
